SRM709 div1 Xscoregame(状压dp)

题目大意:

给定一个序列a,包含n个数(n<=15),每个数的大小小于等于50

初始时x = 0,让你每次选a中的一个数y,使得x = x + x^y

问如何安排选择的次序,使得最终结果最大。

考虑状态压缩,dp[S]表示选了S状态的数的最大结果

我们发现这样做是错误的,因为目前的最大并不意味最后的最大

但是我们会发现,y最大只有50,所以x的大于63的部分不会发生变化,只有小于64的部分会受到y异或的结果

所以我们用dp[S][t]表示:选了S状态的数,小于64部分为t是否可行

然后用dp[S][64]代表大于64部分的大小

选第i个数加入的转移就是,先求出小于64部分与A[i]异或的最大值Max

然后大于64部分的大小就是2*dp[S][64] + (Max>>6)

找到所有小于64部分的异或>>6大于1的值,然后更新那些可行的状态即可

最后输出就是大于64的部分<<6再加上小于64部分最大的可行解

#include <cstdio>
#include <cmath>
#include <cstring>
#include <ctime>
#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <sstream>
#include <typeinfo>
#include <fstream>
#include <queue>
using namespace std;
void print(int x){
    cout<<"*";
    while(x){
        if(x&1) cout<<1;
        else cout<<0;
        x>>=1;
    }
    cout<<endl;
}
long long dp[(1<<15) + 1][100];
queue<int> Q;
int vis[(1<<15) + 1];

void Find(int S){
    for(int i = 0; i < 64; i++) if(dp[S][i]) cout<<i<<" "; cout<<dp[S][64];
    cout<<endl;
}

class Xscoregame {
    public:
    int getscore(vector<int> A) {
        int n = A.size();
        Q.push(0);
        dp[0][0] = 1;
        while(!Q.empty()){
            int S = Q.front(); Q.pop();
            //print(S);
            //Find(S);
            for(int i = 0; i < n; i++){
                if(S&(1<<i)) continue;
                int Max = 0;
                for(int j = 0; j < 64; j++){
                    if(!dp[S][j]) continue;
                    Max = max(Max, j + (j^A[i]));
                }
                if(Max == 0) continue;
                if(dp[S|(1<<i)][64] > 2*dp[S][64] + (Max>>6)) continue;
                if(dp[S|(1<<i)][64] != 2*dp[S][64] + (Max>>6))
                    for(int j = 0; j < 64; j++) dp[S|(1<<i)][j] = 0;
                if(!vis[S|(1<<i)]) Q.push(S|(1<<i)); vis[S|(1<<i)] = 1;
                dp[S|(1<<i)][64] = 2*dp[S][64] + (Max>>6);
                for(int j = 0; j < 64; j++){
                    if(!dp[S][j]) continue;
                    int temp = j + (j^A[i]);
                    if((temp>>6) == (Max>>6)) dp[S|(1<<i)][temp&63] = 1;
                }
            }
        }
        long long ans = 0, temp = 0;
        for(int i = 63; i >= 0; i--) if(dp[(1<<n)-1][i]) { temp = i; break; }
        ans += (dp[(1<<n)-1][64]<<6) + temp;
        return ans;
    }
};
时间: 2024-08-03 22:03:22

SRM709 div1 Xscoregame(状压dp)的相关文章

ZOJ3305Get Sauce 状压DP,

状压DP的题目留个纪念,首先题意一开始读错了,搞了好久,然后弄好了,觉得DFS可以,最后超时,修改了很久还是超时,没办法看了一下n的范围,然后觉得状压可以,但是没有直接推出来,就记忆化搜索了一下,可是一直错,莫名奇妙,然后没办法看了一下题解,发现了下面这个比较好的方法,然后按照这个方程去推,然后敲,也是WA了好多把,写的太搓了,没人家的清楚明了,唉~也算是给自己留个纪念,状压一直做的都不太好~唉~还好理解了, 参考了  http://blog.csdn.net/nash142857/articl

poj 2411 Mondriaan&#39;s Dream(状压DP)

Mondriaan's Dream Time Limit: 3000MS   Memory Limit: 65536K Total Submissions: 12232   Accepted: 7142 Description Squares and rectangles fascinated the famous Dutch painter Piet Mondriaan. One night, after producing the drawings in his 'toilet series

(状压dp)uva 10817 Headmaster&#39;s Headache

题目地址 1 #include <bits/stdc++.h> 2 typedef long long ll; 3 using namespace std; 4 const int MAX=1e5+5; 5 const int INF=1e9; 6 int s,m,n; 7 int cost[125]; 8 //char sta[MAX]; 9 string sta; 10 int able[125]; 11 int dp[125][1<<8][1<<8]; 12 in

HDU5816 Hearthstone(状压DP)

题目 Source http://acm.hdu.edu.cn/showproblem.php?pid=5816 Description Hearthstone is an online collectible card game from Blizzard Entertainment. Strategies and luck are the most important factors in this game. When you suffer a desperate situation an

HDU 4336 容斥原理 || 状压DP

状压DP :F(S)=Sum*F(S)+p(x1)*F(S^(1<<x1))+p(x2)*F(S^(1<<x2))...+1; F(S)表示取状态为S的牌的期望次数,Sum表示什么都不取得概率,p(x1)表示的是取x1的概率,最后要加一因为有又多拿了一次.整理一下就可以了. 1 #include <cstdio> 2 const int Maxn=23; 3 double F[1<<Maxn],p[Maxn]; 4 int n; 5 int main() 6

Travel(HDU 4284状压dp)

题意:给n个城市m条路的网图,pp在城市1有一定的钱,想游览这n个城市(包括1),到达一个城市要一定的花费,可以在城市工作赚钱,但前提有工作证(得到有一定的花费),没工作证不能在该城市工作,但可以走,一个城市只能工作一次,问pp是否能游览n个城市回到城市1. 分析:这个题想到杀怪(Survival(ZOJ 2297状压dp) 那个题,也是钱如果小于0就挂了,最后求剩余的最大钱数,先求出最短路和 Hie with the Pie(POJ 3311状压dp) 送披萨那个题相似. #include <

BZOJ 1087: [SCOI2005]互不侵犯King( 状压dp )

简单的状压dp... dp( x , h , s ) 表示当前第 x 行 , 用了 h 个 king , 当前行的状态为 s . 考虑转移 : dp( x , h , s ) = ∑ dp( x - 1 , h - cnt_1( s ) , s' ) ( s and s' 两行不冲突 , cnt_1( s ) 表示 s 状态用了多少个 king ) 我有各种预处理所以 code 的方程和这有点不一样 ------------------------------------------------

BZOJ 1072 排列 状压DP

题意:链接 方法:状压DP? 题解:这题其实没啥好写的,不算很难,推一推就能搞出来. 首先看到这个问题,对于被d整除这个条件,很容易就想到是取余数为0,所以想到可能状态中刚开始含有取余数. 先说我的第一个想法,f[i][j]表示选取i个数且此时的mod为j,这样的思想是第一下蹦出来的,当时想的就是在线来搞最终的答案.不过转瞬即发现,这TM不就是暴力吗魂淡!并没有什么卵用,于是开始想这个状态可不可以做什么优化. 显然第二维的j并不需要太大的优化,暂且先将其搁置一边,来考虑第一维的i怎么优化. 把滚

COdeforces#417D Cunning Gena(状压DP)

A boy named Gena really wants to get to the "Russian Code Cup" finals, or at least get a t-shirt. But the offered problems are too complex, so he made an arrangement with his n friends that they will solve the problems for him. The participants

UVA 10817 Headmaster&#39;s Headache 状压DP

记录两个状态S1,S2分别记录哪些课程被1个人教过或2个人教过,然后记忆化搜索 UVA - 10817 Headmaster's Headache Time Limit: 3000MS   Memory Limit: Unknown   64bit IO Format: %lld & %llu Submit Status Description Problem D: Headmaster's Headache Time limit: 2 seconds The headmaster of Spr